package com.example.tugen.eat;

import android.Manifest;
import android.annotation.SuppressLint;
import android.app.AlertDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.IntentSender;
import android.content.pm.PackageManager;
import android.location.Location;
import android.net.Uri;
import android.os.StrictMode;
import android.support.annotation.NonNull;
import android.support.constraint.ConstraintLayout;
import android.support.design.widget.FloatingActionButton;
import android.support.v4.app.ActivityCompat;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.util.Log;
import android.view.Gravity;
import android.view.LayoutInflater;
import android.view.View;
import android.widget.Button;
import android.widget.CompoundButton;
import android.widget.ImageView;
import android.widget.PopupWindow;
import android.widget.RelativeLayout;
import android.widget.Switch;
import android.widget.TextView;
import android.widget.Toast;

import com.google.android.gms.common.api.ResolvableApiException;
import com.google.android.gms.location.FusedLocationProviderClient;
import com.google.android.gms.location.LocationCallback;
import com.google.android.gms.location.LocationRequest;
import com.google.android.gms.location.LocationResult;
import com.google.android.gms.location.LocationServices;
import com.google.android.gms.location.LocationSettingsRequest;
import com.google.android.gms.location.LocationSettingsResponse;
import com.google.android.gms.location.SettingsClient;
import com.google.android.gms.maps.CameraUpdateFactory;
import com.google.android.gms.maps.GoogleMap;
import com.google.android.gms.maps.OnMapReadyCallback;
import com.google.android.gms.maps.SupportMapFragment;
import com.google.android.gms.maps.model.LatLng;
import com.google.android.gms.maps.model.Marker;
import com.google.android.gms.maps.model.MarkerOptions;
import com.google.android.gms.tasks.OnFailureListener;
import com.google.android.gms.tasks.OnSuccessListener;
import com.google.android.gms.tasks.Task;
import com.google.gson.Gson;
import com.google.maps.android.SphericalUtil;
import com.google.maps.android.clustering.ClusterManager;



import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.net.HttpURLConnection;
import java.net.MalformedURLException;
import java.net.URL;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.HashMap;
import java.util.Iterator;

import java.util.List;
import java.util.Locale;

public class MainActivity extends AppCompatActivity implements OnMapReadyCallback {

    LatLng KUOPIO_LOCATION = new LatLng(62.90, 27.67);

    GoogleMap mMap;
    int currentday=0;

    private FusedLocationProviderClient mFusedLocationClient;
    private LocationRequest mLocationRequest = new LocationRequest();
    private boolean mRequestingLocationUpdates = false;
    private static final int REQUEST_CHECK_SETTINGS = 0;
    private LocationCallback mLocationCallback;


    customInfoWindowAdapter customInfoWindow = new customInfoWindowAdapter(this);

    private PopupWindow popupWindow;
    private View popupView;

    private LatLng lastknownlocation=new LatLng(0,0);
    private Marker userLocationPin = null;

    ArrayList<restaurant> ravintolat = new ArrayList<restaurant>();
    HashMap<String,Integer> viittaus = new HashMap<String, Integer>();

    // Declare a variable for the cluster manager.
    private ClusterManager<MapItem> mClusterManager;
    private ClusterIconRendered rndr = null;



    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        setContentView(R.layout.activity_main);

        requestPermissions();

        solvedate();

        mFusedLocationClient = LocationServices.getFusedLocationProviderClient(this);

        setupLocationRequest();

        startLocationRequests();

        setupLocationInfoHandling();

        setupfloatingbuttons();




        //https://api.jsonbin.io/b/5bfe4cf28d9b836588a0e21b





        // Obtain the SupportMapFragment and get notified when the map is ready to be used.
        SupportMapFragment mapFragment = (SupportMapFragment) getSupportFragmentManager().findFragmentById(R.id.map);
        mapFragment.getMapAsync(this);







    }



    @Override
    protected void onDestroy() {
        super.onDestroy();
        Log.d("Test","App destroyed");
    }

    @Override
    protected void onResume() {
        super.onResume();
        if (mRequestingLocationUpdates) {
            startLocationUpdates();
        }
    }


    //TODO Calculate distance in meters between two locations
    int calculateDistance(LatLng userposition,LatLng target){

        int distance=0;
        return distance;
    }


    //TODO returns Arraylist of the restaurants that are sorted to nearest to furthest
    ArrayList<restaurant> sortByDistance(ArrayList<restaurant> unsorted,LatLng userlocation){

        ArrayList<restaurant> sortedRestaurants = new ArrayList<restaurant>();

        for (int i = 0;i<unsorted.size();i++){

            restaurant current = unsorted.get(i);

            current.getLocation();//this gives LatLng coordinates of the restaurant
        }



        return sortedRestaurants;
    }






    @Override
    protected void onPause() {
        super.onPause();
        stopLocationUpdates();

    }

    private void setupLocationInfoHandling() {
        //what to do when location info arrives
        mLocationCallback = new LocationCallback() {
            @Override
            public void onLocationResult(LocationResult locationResult) {
                if (locationResult == null) {
                    return;
                }
                for (Location location : locationResult.getLocations()) {
                    Log.d("Test","Location info arrived");
                    lastknownlocation = new LatLng(location.getLatitude(), location.getLongitude());
                    if (userLocationPin.isVisible()== false){
                        userLocationPin.setPosition(lastknownlocation);
                        userLocationPin.setVisible(true);
                        userLocationPin.setSnippet("your location");
                    }
                    else{
                        userLocationPin.setPosition(lastknownlocation);
                        Log.d("Test","user position updated");
                    }


                   // Toast.makeText(MainActivity.this, "Location:"+location.getLatitude()+ "  "+ location.getLongitude(), Toast.LENGTH_SHORT).show();
                }
            };
        };
    }

    private void setupfloatingbuttons() {
        LayoutInflater layoutInflater = (LayoutInflater)getBaseContext().getSystemService(LAYOUT_INFLATER_SERVICE);
        popupView = layoutInflater.inflate(R.layout.settingsfloat,null);
        popupWindow = new PopupWindow(popupView, RelativeLayout.LayoutParams.WRAP_CONTENT,RelativeLayout.LayoutParams.WRAP_CONTENT);


        FloatingActionButton fab = findViewById(R.id.floatbutton);
        fab.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {

                if(popupWindow.isShowing()){
                    popupWindow.dismiss();
                }
                else{
                    FloatingActionButton button = (FloatingActionButton) findViewById(R.id.floatbutton);

                    int[] location = new int[2];
                    button.getLocationInWindow(location);
                    Log.d("point","1: "+location[0]+"  2: "+location[1]);






                    int mCurrentX = location[0]-300;
                    int mCurrentY = location[1]-200;
                    popupWindow.showAtLocation(view, Gravity.NO_GRAVITY, mCurrentX, mCurrentY);


                }


            }
        });


        final Button nearestbutton = (Button) popupView.findViewById(R.id.button);

        nearestbutton.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
               findNearests();

            }});




        Switch onOffSwitch = (Switch)  popupView.findViewById(R.id.clusterswitch);
        onOffSwitch.setOnCheckedChangeListener(new CompoundButton.OnCheckedChangeListener() {

            @Override
            public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
                Log.v("Switch State=", ""+isChecked);
                mClusterManager.clearItems();
                if(isChecked){
                    rndr.setMinClusterSize(2);

                }
                else {


                    rndr.setMinClusterSize(10002);
                }


                addItems();
                mClusterManager.cluster();
            }

        });

    }

    @Override
    public void onMapReady(GoogleMap googleMap) {
        mMap = googleMap;


        //move camera above kuopio
        mMap.moveCamera(CameraUpdateFactory.newLatLngZoom(KUOPIO_LOCATION,13));

        parsejson();




        //Initialize user location marker
         userLocationPin = mMap.addMarker(new MarkerOptions()
                .position(KUOPIO_LOCATION)
                .draggable(true)
                .visible(false));


        setUpClusterer();


        mMap.setOnInfoWindowClickListener(new GoogleMap.OnInfoWindowClickListener() {
            @Override
            public void onInfoWindowClick(Marker marker) {
                showExtrainfo(marker);
            }
        });



        mMap.setOnMarkerClickListener(new GoogleMap.OnMarkerClickListener() {
            @Override
            public boolean onMarkerClick(Marker marker) {

                //We dont want to do these to users location pin
                if(marker.getTitle()!=null){
                InfoWindowData infowindow = new InfoWindowData();

                String name = marker.getSnippet().toLowerCase()+"_full";

                infowindow.setImage(name);
                infowindow.setInfo("open hours info");
                //List <String> a =  Arrays.asList();
                infowindow.setmenu(ravintolat.get(viittaus.get(marker.getTitle())).getLunches().get(currentday));

                //TODO
                //hae ravintolan aukiolot
                //hae ravintolan ruokalista

                mMap.setInfoWindowAdapter(customInfoWindow);
                marker.setTag(infowindow);
                double la= marker.getPosition().latitude;
                double lo = marker.getPosition().longitude;
                LatLng pos = new LatLng(la,lo);

                mMap.moveCamera(CameraUpdateFactory.newLatLng(pos));
            }


                return false;

            }
        });








        Log.d("Test","Map ready complete");

    }

    private void startLocationRequests() {
        LocationSettingsRequest.Builder builder = new LocationSettingsRequest.Builder().addLocationRequest(mLocationRequest);

        SettingsClient client = LocationServices.getSettingsClient(this);
        Task<LocationSettingsResponse> task = client.checkLocationSettings(builder.build());
        task.addOnSuccessListener(this, new OnSuccessListener<LocationSettingsResponse>() {
            @Override
            public void onSuccess(LocationSettingsResponse locationSettingsResponse) {

                Toast.makeText(MainActivity.this, "Location settings satisfied", Toast.LENGTH_SHORT).show();
                mRequestingLocationUpdates=true;
                startLocationUpdates();
            }
        });
        task.addOnFailureListener(this, new OnFailureListener() {
            @Override
            public void onFailure(@NonNull Exception e) {
                if (e instanceof ResolvableApiException) {
                    // Location settings are not satisfied, but this can be fixed
                    // by showing the user a dialog.
                    try {
                        // Show the dialog by calling startResolutionForResult(),
                        // and check the result in onActivityResult().
                        ResolvableApiException resolvable = (ResolvableApiException) e;
                        resolvable.startResolutionForResult(MainActivity.this,
                                REQUEST_CHECK_SETTINGS);
                    } catch (IntentSender.SendIntentException sendEx) {
                        // Ignore the error.
                    }
                }
            }
        });

    }

    private void requestPermissions(){

        if (ActivityCompat.checkSelfPermission(this, Manifest.permission.ACCESS_FINE_LOCATION) != PackageManager.PERMISSION_GRANTED && ActivityCompat.checkSelfPermission(this, Manifest.permission.ACCESS_COARSE_LOCATION) != PackageManager.PERMISSION_GRANTED) {
            ActivityCompat.requestPermissions(MainActivity.this,
                    new String[]{Manifest.permission.ACCESS_FINE_LOCATION},
                    1);

            return;
        }

    }

    public void onRequestPermissionsResult(int requestCode, String permissions[], int[] grantResults) {
        switch (requestCode) {
            case 1: {

                // If request is cancelled, the result arrays are empty.
                if (grantResults.length > 0
                        && grantResults[0] == PackageManager.PERMISSION_GRANTED) {


                } else {
                    // permission denied

                    Toast.makeText(MainActivity.this, "Permission denied to read fine location", Toast.LENGTH_SHORT).show();
                }
                return;
            }

            // other 'case' lines to check for other
            // permissions this app might request
        }
    }

    private void solvedate(){
        Calendar calendar = Calendar.getInstance();
        Date date = calendar.getTime();
        String day= new SimpleDateFormat("EEEE", Locale.ENGLISH).format(date.getTime());
        Log.d("date","day: "+day);

        switch (day) {
            case "Monday":
                currentday=0;
                break;
            case "Tuesday":
                currentday=1;
                break;
            case "Wednesday":
                currentday=2;
                break;
            case "Thursday":
                currentday=3;
                break;
            case "Friday":
                currentday=4;
                break;
            case "saturday":
                currentday=5;
                break;
            case "Sunday":
                currentday=6;
                break;
        }
    }

    protected void setupLocationRequest() {
        mLocationRequest.setInterval(10000);
        mLocationRequest.setFastestInterval(5000);
        mLocationRequest.setPriority(LocationRequest.PRIORITY_HIGH_ACCURACY);
    }

    @SuppressLint("MissingPermission")
    private void startLocationUpdates() {
        mFusedLocationClient.requestLocationUpdates(mLocationRequest,
                mLocationCallback,
                null /* Looper */);
    }

    @SuppressLint("MissingPermission")
    private void stopLocationUpdates() {

        try {
            mFusedLocationClient.removeLocationUpdates(mLocationCallback);
            Log.d("test","Location updates stopped");

        } catch (SecurityException unlikely) {

        }

    }

    public void parsejson(){

        StrictMode.ThreadPolicy policy = new StrictMode.ThreadPolicy.Builder().permitAll().build();
        StrictMode.setThreadPolicy(policy);

        String js = null;
        URL url;
        StringBuffer response = new StringBuffer();
        try {
            url = new URL("https://api.jsonbin.io/b/5bfe51ad8d9b836588a0e384/latest");
        } catch (MalformedURLException e) {
            throw new IllegalArgumentException("invalid url");
        }

        HttpURLConnection conn = null;
        try {
            conn = (HttpURLConnection) url.openConnection();
            conn.setDoOutput(false);
            conn.setDoInput(true);
            conn.setUseCaches(false);
            conn.setRequestMethod("GET");
            conn.setRequestProperty("Content-Type", "application/x-www-form-urlencoded;charset=UTF-8");

            // handle the response
            int status = conn.getResponseCode();
            if (status != 200) {
                throw new IOException("Post failed with error code " + status);
            } else {
                BufferedReader in = new BufferedReader(new InputStreamReader(conn.getInputStream()));
                String inputLine;
                while ((inputLine = in.readLine()) != null) {
                    response.append(inputLine);
                }
                in.close();
            }
        } catch (Exception e) {
            e.printStackTrace();
            Log.d("Test","failed");
        } finally {
            if (conn != null) {
                conn.disconnect();
                Log.d("Test","finally");
            }


             js = response.toString();
            Log.d("Test",""+js);
        }

        Gson gson = new Gson();


            Restaurants rest = gson.fromJson(js,Restaurants.class);



            ArrayList<restaurant> list = rest.getRestaurants();
            Log.d("Test","koko: "+list.size());
            Iterator<restaurant> itr =list.iterator();

            while (itr.hasNext()){
                restaurant r = itr.next();
                ravintolat.add(r);
                viittaus.put(r.getName(),viittaus.size());

            }











    }

    public String readFile(String fileName) throws IOException
    {
        BufferedReader reader = null;
        //reader = new BufferedReader(new InputStreamReader(getAssets().open("restaurants.json"), "UTF-8"));

        String content = "";
        String line;
        while ((line = reader.readLine()) != null)
        {
            content = content + line;
        }

        Log.d("luku", "content "+content);
        return content;

    }


    private void setUpClusterer() {
        // Position the map.
        //mMap.moveCamera(CameraUpdateFactory.newLatLngZoom((KUOPIO_LOCATION), 10));

        // Initialize the manager with the context and the map.
        // (Activity extends context, so we can pass 'this' in the constructor.)
        mClusterManager = new ClusterManager<MapItem>(this, mMap);


        // Point the map's listeners at the listeners implemented by the cluster
        // manager.
        mMap.setOnCameraIdleListener(mClusterManager);
        mMap.setOnMarkerClickListener(mClusterManager);
        rndr = new ClusterIconRendered(this.getApplicationContext(),mMap,mClusterManager);
        mClusterManager.setRenderer(rndr);
        mClusterManager.setAnimation(false);


        // Add cluster items (markers) to the cluster manager.
        addItems();
    }

    private void findNearests(){

        Double shortest = null;
        restaurant nearest=null;
        for (int i=0;i<ravintolat.size();i++){
            double distance = SphericalUtil.computeDistanceBetween(lastknownlocation, ravintolat.get(i).getLocation());

            if (shortest==null||shortest>distance){
                shortest=distance;
                nearest = ravintolat.get(i);
            }

        }

        if(nearest==null){
            Toast.makeText(MainActivity.this, "No nearest restaurant found", Toast.LENGTH_SHORT).show();
        }
        else{

            mMap.moveCamera(CameraUpdateFactory.newLatLngZoom((nearest.getLocation()), 16));
        }

    }

    private void addItems() {



        //lets create markers to the map
        for(int i=0;i<ravintolat.size();i++){

            //name of the marker image file in drawable

            Log.d("Test",""+ravintolat.get(i).getName());
            String name = ravintolat.get(i).getCompany().toLowerCase()+"_pin";

            //This is for finding context
            ConstraintLayout a = (ConstraintLayout)findViewById(R.id.Constraintlayout);
            Context context = a.getContext();


            int pinni = context.getResources().getIdentifier(name, "drawable", context.getPackageName());
            Log.d("Test","added");
            //Add new marker to the map

            MapItem clustermarker = new MapItem(ravintolat.get(i).getLat(),
                                                ravintolat.get(i).getLng(),
                                                ravintolat.get(i).getName(),
                                                ravintolat.get(i).getCompany(),pinni);
            mClusterManager.addItem(clustermarker);

        }




    }

    void showExtrainfo(final Marker marker){
        final AlertDialog.Builder ad = new AlertDialog.Builder(this);
        final AlertDialog extreinfodialog= ad.create();

        String name = marker.getSnippet().toLowerCase()+"_full";
        View rootView = LayoutInflater.from(this).inflate(R.layout.extrainfo_layout,null);

        Button navigate = (Button) rootView.findViewById(R.id.navigateButton);
        Button close = (Button) rootView.findViewById(R.id.closeButton);

        navigate.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                LatLng location = marker.getPosition();

                Uri gmmIntentUri = Uri.parse("google.navigation:q="+location.latitude+","+location.longitude);
                Intent mapIntent = new Intent(Intent.ACTION_VIEW, gmmIntentUri);
                mapIntent.setPackage("com.google.android.apps.maps");
                startActivity(mapIntent);

            }});

        close.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                extreinfodialog.dismiss();


            }});




        int imageId = this.getResources().getIdentifier(name,
                "drawable", this.getPackageName());


        ImageView infoimage= (ImageView) rootView.findViewById(R.id.infoimageView);
        TextView rname = (TextView) rootView.findViewById(R.id.restaurantname);
        TextView Menutext = (TextView) rootView.findViewById(R.id.menutextView);


        infoimage.setImageResource(imageId);


        extreinfodialog.setView(rootView);

        InfoWindowData infoWindowData = (InfoWindowData) marker.getTag();


        List<String> daysmenu = infoWindowData.getmenu();

        String menutext=null;

        for(int i=0;i<daysmenu.size();i++){
            String choise = daysmenu.get(i);

            if(menutext==null){
                menutext= choise;
            }
            else{

                if(choise.charAt(choise.length()-1)==':'){
                    choise=" \n"+choise;
                }
                menutext=menutext +" \n"+choise;

            }



        }

        Menutext.setText(menutext);
        rname.setText(marker.getTitle());

        extreinfodialog.show();



    }





}
